<?php
    require_once "navbar.php"; //Agrega el NavBar
    require_once('clase.php'); //Incluye el archivo clase.php

    // Variables en caso de no contar con alguna fecha
    $fechaActual = date('Y-m-d');
    $semana_pasada = date("Y-m-d",strtotime($fechaActual."- 1 week"));
    $semana_antepasada = date("Y-m-d",strtotime($fechaActual."- 2 week"));

    // Variable de categoría en caso de recibir o no parámetros
    if(isset($_GET['cat'])){
        $cate = $_GET['cat'];
    }
    else{
        $cate = "TODAS";
    }

    // Variable de tipo de ticket (creado,modificado,cerrado,todos) en caso de recibir o no parámetros
    if(isset($_GET['tipo'])){
        $tipo = $_GET['tipo'];
    }
    else{
        $tipo = "All";
    }

    // Variables de fechas en caso de recibir o no parámetros
    if(isset($_GET['fechaini']) && isset($_GET['fechafin'])){
        $fechaini = $_GET['fechaini'];
        $fechafin = $_GET['fechafin'];
    }
    else if(isset($_GET['fechaini']) && !isset($_GET['fechafin'])){
        $fechaini = $_GET['fechaini'];
        $fechaActual;
    }
    else if(!isset($_GET['fechaini']) && isset($_GET['fechafin'])){
        $fechaini = $semana_antepasada;
        $fechafin = $_GET['fechafin'];
    }
    else if(!isset($_GET['fechaini']) && !isset($_GET['fechafin'])){
        $fechaini = $semana_antepasada;
        $fechafin = $semana_pasada;
    }

    // Instancia de los objectos y llamados a las clases de categoria
    $categoria = $categoria->categoria_categoria(); 
    $categoria1 = $categoria1->categoria_all_tickets($fechaini, $fechafin, $tipo, $cate);
    $categoria2 = $categoria2->categoria_cuantos_tickets($fechaini, $fechafin, $tipo, $cate);
    $categoria3 = $categoria3->categoria_cuantos_categoria($fechaini, $fechafin, $tipo);

    // Proceso para obtener el índice de cubrimiento
    if($categoria2['cuantos'] == 0){
        $indice = 0;
    }
    else{
        $indice = ROUND(($categoria2['cerrados'] * 100)/$categoria2['cuantos'],2);
    }

    // Funcion para llenar un arreglo y trabajarlo en el JS para la gráfica de pastel referencia categoria.js
    $count = array();
    foreach($categoria3 as $cat3){
        $count[] = $cat3;
    }
?>
    <!-- Nombre de la página para resaltar en el navbar referencia regis.js -->
    <input name="nomPag" id="nomPag" type="hidden" value="categoria"/>

    <!-- Inicio de la página -->
    <div class="container-fluid">

        <!-- Encabezado-->
        <div class="d-sm-flex align-items-center justify-content-between mb-4">
            <h1 class="h3 mb-0 text-gray-800">Dashboard Categoria</h1>
        </div>

        <!-- Formulario para filtrar el contenido de los tikets -->
        <form class="form-horizontal" role="form" id="categoria_tiempo" onKeyPress="if(event.keyCode == 13) event.returnValue = false;">
            <div class="row">

                <!-- Selección te tipo de ticket -->
                <div class="col-xl-2 col-sm-6">
                    <div class="form-group">
                        <label for="buscar">Buscar</label>
                        <select id="categoria_buscar" class="form-control text-uppercase" name="buscar" required >
                        <?php if($tipo == "All"){
                                    echo '<option value="All" Selected>TODOS</option>
                                    <option value="Open">ABIERTO</option>
                                    <option value="Created">CREADO</option>
                                    <option value="Updated">MODIFICADO</option>
                                    <option value="Closed">CERRADO</option>';
                                }
                                elseif($tipo == "Open"){
                                    echo '<option value="All">TODOS</option>
                                    <option value="Open" Selected>ABIERTO</option>
                                    <option value="Created">CREADO</option>
                                    <option value="Updated">MODIFICADO</option>
                                    <option value="Closed">CERRADO</option>';
                                }
                                elseif($tipo == "Created"){
                                    echo '<option value="All">TODOS</option>
                                    <option value="Open">ABIERTO</option>
                                    <option value="Created" Selected>CREADO</option>
                                    <option value="Updated">MODIFICADO</option>
                                    <option value="Closed">CERRADO</option>';
                                }
                                elseif($tipo == "Updated"){
                                    echo '<option value="All">TODOS</option>
                                    <option value="Open">ABIERTO</option>
                                    <option value="Created">CREADO</option>
                                    <option value="Updated" Selected>MODIFICADO</option>
                                    <option value="Closed">CERRADO</option>';
                                }
                                elseif($tipo == "Closed"){
                                    echo '<option value="All">TODOS</option>
                                    <option value="Open">ABIERTO</option>
                                    <option value="Created">CREADO</option>
                                    <option value="Updated">MODIFICADO</option>
                                    <option value="Closed" Selected>CERRADO</option>';
                                }?>
                        </select>
                    </div>
                </div>

                <!-- Selección de categoría del ticket -->
                <div class="col-xl-4 col-sm-6">
                    <div class="form-group">
                        <label for="categoria">Categoria</label>
                        <select id="categoria_cat" class="form-control text-uppercase" name="categoria" required >
                                <option value="TODAS" selected>TODAS</option>
                                <?php foreach($categoria as $cat): 
                                    if($cate == $cat['topic_id']){?>
                                        <option value="<?= $cat['topic_id']; ?>" selected> <?= $cat['topic']; ?> </option>    
                                <?php }
                                    else{ ?>
                                        <option value="<?= $cat['topic_id']; ?>"> <?= $cat['topic']; ?> </option>
                                <?php
                                        }
                                endforeach; ?>
                        </select>
                    </div>
                </div>

                <!-- Fecha Inicial del ticket para buscar a partir de está -->
                <div class="col-xl-2 col-sm-6">
                    <div class="form-group">
                        <label for="fechaini">Fecha Inicial</label>
                        <input type="date"  class="form-control text-uppercase"  id="categoria_fechaini" name="fecha_ini" value="<?=$fechaini;?>">
                    </div>
                </div>

                <!-- Fecha Final del ticket para buscar hasta de está -->
                <div class="col-xl-2 col-sm-6">
                    <div class="form-group">
                        <label for="fechafin">Fecha Final</label>
                        <input type="date"  class="form-control text-uppercase"  id="categoria_fechafin" name="fecha_fin" value="<?=$fechafin;?>">
                    </div>
                </div>

                <!-- Botón para aplicar los filtros -->
                <div class="col-xl-2 col-sm-6">
                    <label for="filtrar" class="text-light">Filtrar</label>
                    <br>
                    <button type="submit" class="btn btn-warning btn-icon-split mb-3">
                        <span class="icon text-white-75">
                            <i class="fas fa-filter"></i>
                        </span>
                        <span class="text">Filtrar</span>
                    </button>
                </div>
            </div>
        </form>

        <!-- Etiquetas-->
        <div class="row">

            <!-- Tickets Totales -->
            <div class="col-xl-3 col-md-6 mb-4">
                <div class="card border-left-info shadow h-100 py-2">
                    <div class="card-body">
                        <div class="row no-gutters align-items-center">
                            <div class="col mr-2">
                                <div class="text-xs font-weight-bold text-info text-uppercase mb-1">
                                    TICKETS TOTALES  
                                </div>
                                <div class="h5 mb-0 font-weight-bold text-gray-800">
                                    <?= $categoria2['cuantos']; ?>
                                </div>
                            </div>
                            <div class="col-auto">
                                <i class="fas fa-ticket-alt fa-2x text-gray-300"></i>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            <!-- Tickets Abiertos -->
            <div class="col-xl-3 col-md-6 mb-4">
                <div class="card border-left-warning shadow h-100 py-2">
                    <div class="card-body">
                        <div class="row no-gutters align-items-center">
                            <div class="col mr-2">
                                <div class="text-xs font-weight-bold text-warning text-uppercase mb-1">
                                    Tickets Abiertos</div>
                                <div class="h5 mb-0 font-weight-bold text-gray-800">
                                    <label for="categoria_Abiertos" id="categoria_Abiertos">
                                    <?= $categoria2['abiertos']; ?>
                                    </label>
                                </div>
                            </div>
                            <div class="col-auto">
                                <i class="fas fa-folder-open fa-2x text-gray-300"></i>
                            </div>
                        </div>
                    </div>
                </div>
            </div>

            <!-- Tickets Cerrados -->
            <div class="col-xl-3 col-md-6 mb-4">
                <div class="card border-left-success shadow h-100 py-2">
                    <div class="card-body">
                        <div class="row no-gutters align-items-center">
                            <div class="col mr-2">
                                <div class="text-xs font-weight-bold text-success text-uppercase mb-1">
                                    Tickets Cerrados</div>
                                <div class="h5 mb-0 font-weight-bold text-gray-800">
                                    <label for="categoria_Cerrados" id="categoria_Cerrados">
                                    <?= $categoria2['cerrados']; ?>
                                    </label>
                                </div>
                            </div>
                            <div class="col-auto">
                                <i class="fas fa-clipboard-check fa-2x text-gray-300"></i>
                            </div>
                        </div>
                    </div>
                </div>
            </div>

            <!-- Índice de Cubrimiento -->
            <div class="col-xl-3 col-md-6 mb-4">
                <div class="card border-left-primary shadow h-100 py-2">
                    <div class="card-body">
                        <div class="row no-gutters align-items-center">
                            <div class="col mr-2">
                                <div class="text-xs font-weight-bold text-primary text-uppercase mb-1">Índice de Cubrimiento
                                </div>
                                <div class="row no-gutters align-items-center">
                                    <div class="col-auto">
                                        <div id="categoria_cubrimiento" class="h5 mb-0 mr-3 font-weight-bold text-gray-800"><?= $indice ?></div>
                                    </div>
                                    <div class="col">
                                        <div class="progress progress-sm mr-2">
                                            <div class="progress-bar bg-primary" role="progressbar"
                                                style="width: <?= $indice ?>%" aria-valuenow="50" aria-valuemin="0"
                                                aria-valuemax="100"></div>
                                        </div>
                                    </div>
                                </div>
                            </div>
                            <div class="col-auto">
                                <i class="fas fa-percentage fa-2x text-gray-300"></i>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>

        <!-- Graficas -->

        <div class="row">
                                                                   
            <!-- Pastel -->
            <div class="col-xl-12 col-lg-12">
                <div class="card shadow mb-4">
                    <!-- Encabezado -->
                    <div
                        class="card-header py-3 d-flex flex-row align-items-center justify-content-between  overflow-auto">
                        <h6 class="m-0 font-weight-bold text-warning">Tickets Por Categoría</h6>
                        
                    </div>
                    <!-- Contenido -->
                    <div class="card-body">
                        <div class="chart-pie">
                            <canvas id="categoria_Circular"></canvas>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <div class="row">
            <?php foreach($categoria as $cat): ?>
                <div class="col-xl-6 col-lg-6">
                    <div class="card shadow mb-4">
                        <a href="#barra_<?=$cat['topic_id']; ?>" class="d-block card-header py-3" data-toggle="collapse"
                            role="button" aria-expanded="true" aria-controls="<?=$cat['topic_id']; ?>">
                            <div class="card-header py-3 d-flex flex-row align-items-center justify-content-between">
                                <h6 class="m-0 font-weight-bold text-warning"><?= $cat['topic']; ?></h6>
                            </div>
                        </a>
                        <div class="collapse hide"  id="barra_<?= $cat['topic_id']; ?>">
                            <div class="card-body">
                                <?php
                                    foreach($categoria3 as $cat3):
                                        if($cat3['topic'] == $cat['topic']){
                                            $open = round((($cat3['abiertos'] * 100)/$cat3['cuantos']), 2);
                                            $close = round((($cat3['cerrados'] * 100)/$cat3['cuantos']), 2);
                                ?>
                                        <div >
                                            <h3>Abiertos <?= $cat3['abiertos'] ?></h3>
                                            <div class="progress progress-sm mr-2">
                                                <div class="progress-bar bg-danger" role="progressbar"
                                                    style="width: <?= $open ?>%" aria-valuenow="50" aria-valuemin="0"
                                                    aria-valuemax="100"></div>
                                            </div>
                                            <br>
                                            <h3>Cerrados <?= $cat3['cerrados'] ?></h3>
                                            <div class="progress progress-sm mr-2">
                                                <div class="progress-bar bg-success" role="progressbar"
                                                    style="width: <?= $close ?>%" aria-valuenow="50" aria-valuemin="0"
                                                    aria-valuemax="100"></div>
                                            </div>
                                        </div>
                                        <div class="mt-4 text-center small">
                                            <span class="mr-2">
                                                <i class="fas fa-circle text-danger"></i> Abiertos
                                            </span>
                                            <span class="mr-2">
                                                <i class="fas fa-circle text-success"></i> Cerrados
                                            </span>
                                        </div>
                                <?php
                                        }
                                    endforeach
                                ?>
                                
                            </div>
                        </div>
                    </div>
                </div>            
            <?php endforeach ?>
        </div>
        
        <!-- DataTable -->
        <div class="row">

            <!-- Encabezado -->
            <div class="col-12">
                <div class="card shadow mb-4">
                    <div class="card-header py-3">
                        <h6 class="m-0 font-weight-bold text-warning">Tickets Generados</h6>
                    </div>

                    <!-- Contenido -->
                    <div class="card-body">
                        <div class="table-responsive">
                            <table id="Categoria" class="table table-striped shadow-sm mt-2" style="width:100%">

                                <thead class="bg-warning text-white">
                                    <tr>
                                        <th scope="col">ID</th>
                                        <th scope="col">Tema</th>
                                        <th scope="col">Descripción</th>
                                        <th scope="col">Usuario</th>
                                        <th scope="col">Área</th>
                                        <th scope="col">Departamento</th>
                                        <th scope="col">Activador</th>
                                        <th scope="col">Sucursal</th>
                                        <th scope="col">Fecha Creación</th>
                                        <th scope="col">Última actualización</th>
                                        <th scope="col">Fecha Cierre</th>
                                        <th scope="col">Atendió</th>
                                        <th scope="col">Departamento Staff</th>
                                        <th scope="col">Tiempo Respuesta</th>
                                        <th scope="col">Tiempo</th>
                                    </tr>
                                </thead>
                                <tbody>
                                <?php foreach($categoria1 as $cat):?> 
                                    <tr>
                                        <td><?= $cat['number']; ?></td>
                                        <td><?= $cat['topic']; ?></td>
                                        <td><?= $cat['subject']; ?></td>
                                        <td><?= $cat['name']; ?></td>
                                        <td><?= $cat['area']; ?></td>
                                        <td><?= $cat['depto']; ?></td>
                                        <td><?= $cat['regional']; ?></td>
                                        <td><?= $cat['sucursal']; ?></td>
                                        <td><?= $cat['created']; ?></td>
                                        <td><?= $cat['lastupdate']; ?></td>
                                        <td><?= $cat['closed']; ?></td>
                                        <td><?= $cat['username']; ?></td>
                                        <td><?= $cat['departamento']; ?></td>
                                        <td><?= $cat['tiempoRespuesta']; ?></td>
                                        <td><?= $cat['tiempo']; ?></td>
                                    </tr>
                                <?php endforeach; ?>
                                </tbody>
                            </table>
                        </div>
                    </div>
                </div>
            </div>
        </div>

    </div>
    <!-- contenido -->
    <script>
        // Función para la creación de las gráficas
        window.onload = function() {
            Categoria_graficas(<?php echo json_encode($count); ?>);
        };
    </script>
    
<?php 
    require_once "footer.php" //Agrega el footer a la página
?>
<!-- Referencia al contenido JS de esta página -->
<script src="js/categoria.js"></script>