<?php
    // Archivo para cifrar y descifrar contraseñas

    // Utiliza el archivo iCifrado en la carperta de interfaz
    require_once('../interface/iCifrado.php');

    // Creación de la clase cifrado implementando la interfaz de iCifrado
    class Cifrado implements iCifrado 
    {
        // función de php para hashear la contraseña
        public static function hash($password) {
            return password_hash($password, PASSWORD_DEFAULT, [16]);
        }

        // función de php que compara el pass que se ingresa con el pass cifrado y devuelve el resultado de la comparación
        public static function verify($password, $hash) {
            return password_verify($password, $hash);
        }
    }

    // Objetos para usar en CambioPass.php y Login.php en data
    $cifrado = new Cifrado();
?>