//Configuración al cargar la página de index
$(document).ready(function() {

	// Configuración del Datatable
    $('#Index').DataTable({
        "language": {													//Idioma
            "lengthMenu": " _MENU_ columnas por página",				//Para el cambio de registros por página
            "zeroRecords": "Ningún resultado",							//Lo que se muestra en la tabla cuando no encuentra coincidencias con la busqueda
            "info": "Página _PAGE_ de _PAGES_",							//Paginación
            "infoEmpty": "No hay registros",							//Lo que se muestra en la tabla cuando no se tiene registros
            "infoFiltered": "(Filtro de _MAX_ registros totales)",		//Mensaje de filtro
            "search": "Buscar","paginate": {							//Búsqueda y botones para moverse en la tabla
                "first": "Primero",
                "last": "Último",
                "next": "Siguiente",
                "previous": "Anterior"
            },
        },
		dom: "Bfrtpi",													//Elementos que se muestran en el contenedor Boton, Búsqueda, Tabla, Paginación, indexación
		buttons: [														//Configuración de botón para exportar a excel
			{
				extend: 'excelHtml5',
				text: '<i class="fas fa-file-excel"></i>',
				titleAttr: 'Exportar a Excel',
				className: 'btn btn-success'
			},
		],
    });
});

// Función que redirecciona a la página index con los parámetros de filtrado establecidos
$(document).on('submit', '#general_tiempo', function(event) {
	event.preventDefault();

	// Obtiene los valores del form en index.php
	let fechaini = document.getElementById('general_fechaini').value;
	let fechafin = document.getElementById('general_fechafin').value;
	let buscar = document.getElementById('general_buscar').value;

	// Redirecciona a la página agregando los parámetros
	$.ajax({
		url: 'index.php',
		success: function() {    
			$("#general_buscar option[value="+ buscar +"]").attr("selected",true);
			location.href = "index.php?fechaini="+fechaini+"&fechafin="+fechafin+"&tipo="+buscar;
		},
		error:function(){
			alert("error");
		}
	});
});

// Gráficas de index 
function General_graficas(){

	// Gráfica de pastel

	// Obtiene los valores de tickets abiertos y cerrados
	let abiertos = parseInt(document.getElementById('general_Abiertos').innerHTML);
	let cerrados = parseInt(document.getElementById('general_Cerrados').innerHTML);

	// Estructura:
	// Obtiene el div donde se mostrará la gráfica
	// Creación del objeto gráfica
	// Tipo de gráfica
	// Configuración de información:
		// Texto que muestra cuando se le sobrepone el cursor
		// Colores de las barras
		// Colores de las barras cuando se le sobrepone el cursor
		// Colores del borde cuando se le sobrepone el cursor
	// Cofiguración de visialización
		//Fondo del div
		//Color de la fuente
		//Color del borde
		//Tamaño del borde
		//Espaciado vertical
		//Espaciado horizontal
		//Muestra o no los encabezados
		//Tamaño de la circunferencia del centro

	let circular = document.getElementById("general_Circular");
	new Chart(circular, {
		type: 'pie',
		data: {
		  	labels: ["abiertos", "Cerrados"],
		  	datasets: [{
				data: [abiertos, cerrados],
				backgroundColor: ['#E74A3B', '#1cc88a'],
				hoverBackgroundColor: ['#EA221F', '#17a673'],
				hoverBorderColor: "rgba(234, 236, 244, 1)",
		  	}],
		},
		options: {
		  	maintainAspectRatio: false,
		  	tooltips: {
				backgroundColor: "rgb(255,255,255)",
				bodyFontColor: "#858796",
				borderColor: '#dddfeb',
				borderWidth: 1,
				xPadding: 1,
				yPadding: 1,
		  	},
		  	legend: {
				display: false,
		  	},
		  	cutoutPercentage: 2,
		},
	});

	// Gráfica de barras
	// Estructura:
	// Obtiene el div donde se mostrará la gráfica
	// Creación del objeto gráfica
	// Tipo de gráfica
	// Configuración de información:
		// Texto que muestra cuando se le sobrepone el cursor
		// Colores de las barras
		// Colores de las barras cuando se le sobrepone el cursor
		// Colores del borde cuando se le sobrepone el cursor
	// Cofiguración de visialización
		// Empieza la gráfica en 0
		// No muestra los encabezados

	let barra = document.getElementById("general_Barras");
	new Chart(barra, {
		type: 'bar',
		data: {
		  	labels: ["abiertos", "Cerrados"],
		  	datasets: [{
				data: [abiertos, cerrados],
				backgroundColor: ['#E74A3B', '#1cc88a'],
				hoverBackgroundColor: ['#EA221F', '#17a673'],
				hoverBorderColor: "rgba(234, 236, 244, 1)",
		  	}],
		},
		options: {
			maintainAspectRatio: false,
			scales: {
				y: {
					beginAtZero: true
				}
			},
		  	legend: {
				display: false,
		  	},
		},
	});
}
