//Configuración al cargar la página de Sucursal
$(document).ready(function() {

	// Configuración del Datatable
	$('#Sucursal').DataTable({
        "language": {													//Idioma
            "lengthMenu": " _MENU_ columnas por página",				//Para el cambio de registros por página
            "zeroRecords": "Ningún resultado",							//Lo que se muestra en la tabla cuando no encuentra coincidencias con la busqueda
            "info": "Página _PAGE_ de _PAGES_",							//Paginación
            "infoEmpty": "No hay registros",							//Lo que se muestra en la tabla cuando no se tiene registros
            "infoFiltered": "(Filtro de _MAX_ registros totales)",		//Mensaje de filtro
            "search": "Buscar","paginate": {							//Búsqueda y botones para moverse en la tabla
                "first": "Primero",
                "last": "Último",
                "next": "Siguiente",
                "previous": "Anterior"
            },
        },
		dom: "Bfrtpi",													//Elementos que se muestran en el contenedor Boton, Búsqueda, Tabla, Paginación, indexación
		buttons: [														//Configuración de botón para exportar a excel
			{
				extend: 'excelHtml5',
				text: '<i class="fas fa-file-excel"></i>',
				titleAttr: 'Exportar a Excel',
				className: 'btn btn-success'
			},
		],
    });
});

// obtiene el elemento donde se muestra la sucursal que se busca
const modsuc = document.getElementById('sucursal_sucursal');

// Al tener el foco en el elemento muestra el modal para buscar la sucursal
modsuc.addEventListener('focus', (event) => {
    $('.busca_suc').load('buscaSucursal.php', function(){
        $('#modal_SelectSucursal').modal('show');
    });
});

//Busquedas dinámicas
function BuscarCentro(){
	let parametros= "parametros="+$('#asigna_busca').val();
	$.ajax({
		data:  parametros,
		url:   'sucursales.php',
		type:  'post',
		success:  function (response) {                 
			$("#contenido").html(response);
		},
		error:function(){
			alert("error");
		}
	});
}

// obtiene la sucursal seleccionada y oculta el modal
function SelectSuc(id){
    document.getElementById('sucursal_sucursal').value = id;
    $('#modal_SelectSucursal').modal('hide');
}

// Función que redirecciona a la página sucursal con los parámetros de filtrado establecidos
$(document).on('submit', '#sucursal_tiempo', function(event) {
	event.preventDefault();

	// Obtiene los valores del form en sucursal.php
	let fechaini = document.getElementById('sucursal_fechaini').value;
	let fechafin = document.getElementById('sucursal_fechafin').value;
	let buscar = document.getElementById('sucursal_buscar').value;
	let categoria = document.getElementById('sucursal_cat').value;
	let sucursal = document.getElementById('sucursal_sucursal').value;

	// Redirecciona a la página agregando los parámetros
	$.ajax({
		url: 'sucursal.php',
		success: function() {    
			location.href = "sucursal.php?fechaini="+fechaini+"&fechafin="+fechafin+"&tipo="+buscar+"&cat="+categoria+"&suc="+sucursal;
		},
		error:function(){
			alert("error");
		}
	});
});

function Sucursal_graficas(suc1){
    let abiertos = parseInt(suc1['abiertos']);
	let cerrados = parseInt(suc1['cerrados']);

	// Estructura:
	// Obtiene el div donde se mostrará la gráfica
	// Creación del objeto gráfica
	// Tipo de gráfica
	// Configuración de información:
		// Texto que muestra cuando se le sobrepone el cursor
		// Colores de las barras
		// Colores de las barras cuando se le sobrepone el cursor
		// Colores del borde cuando se le sobrepone el cursor
	// Cofiguración de visialización
		//Fondo del div
		//Color de la fuente
		//Color del borde
		//Tamaño del borde
		//Espaciado vertical
		//Espaciado horizontal
		//Muestra o no los encabezados
		//Tamaño de la circunferencia del centro

	let circular = document.getElementById("sucursal_Circular");
	new Chart(circular, {
		type: 'pie',
		data: {
		  	labels: ["abiertos", "Cerrados"],
		  	datasets: [{
				data: [abiertos, cerrados],
				backgroundColor: ['#E74A3B', '#1cc88a'],
				hoverBackgroundColor: ['#EA221F', '#17a673'],
				hoverBorderColor: "rgba(234, 236, 244, 1)",
		  	}],
		},
		options: {
		  	maintainAspectRatio: false,
		  	tooltips: {
				backgroundColor: "rgb(255,255,255)",
				bodyFontColor: "#858796",
				borderColor: '#dddfeb',
				borderWidth: 1,
				xPadding: 1,
				yPadding: 1,
		  	},
		  	legend: {
				display: false,
		  	},
		  	cutoutPercentage: 2,
		},
	});

	// Gráfica de barras
	// Estructura:
	// Obtiene el div donde se mostrará la gráfica
	// Creación del objeto gráfica
	// Tipo de gráfica
	// Configuración de información:
		// Texto que muestra cuando se le sobrepone el cursor
		// Colores de las barras
		// Colores de las barras cuando se le sobrepone el cursor
		// Colores del borde cuando se le sobrepone el cursor
	// Cofiguración de visialización
		// Empieza la gráfica en 0
		// No muestra los encabezados

	let barra = document.getElementById("sucursal_Barras");
	new Chart(barra, {
		type: 'bar',
		data: {
		  	labels: ["abiertos", "Cerrados"],
		  	datasets: [{
				data: [abiertos, cerrados],
				backgroundColor: ['#E74A3B', '#1cc88a'],
				hoverBackgroundColor: ['#EA221F', '#17a673'],
				hoverBorderColor: "rgba(234, 236, 244, 1)",
		  	}],
		},
		options: {
			maintainAspectRatio: false,
			scales: {
				y: {
					beginAtZero: true
				}
			},
		  	legend: {
				display: false,
		  	},
		},
	});
}